#ifndef __MARKERGROUP_H__
#define __MARKERGROUP_H__

#include <string>
#include <vector>
#include <map>

using namespace std;

class GroupInfo
{
 public:
  std::string group_name;
  std::vector<int> pos;
  std::vector<float> weight;
  std::vector<float> freq;
  std::vector<std::string> chr;
  int start, end, count;

 public:
  GroupInfo();
 ~GroupInfo();

};

class MarkerGroup
{
 public:
  std::map<std::string, int> index;
  std::vector<std::string> group_names;
  std::map<std::string, GroupInfo> groups;
  int count;
  double min_freq;

 public:
  MarkerGroup();
 ~MarkerGroup();
  void SetMinFreq(double f){min_freq = f;};
  void LoadMarkerGroupInfo(std::string);
  void PrintGroupInfo();
};

#endif
