#include "MarkerGroupData.h"

MarkerGroupData::MarkerGroupData()
{
 case_var_count=0.0;
 ctrl_var_count=0.0;
 case_carrier_count=0;
 ctrl_carrier_count=0;
}

MarkerGroupData::~MarkerGroupData(){}

void MarkerGroupData::EstimateAlleleFreq()
{
 float total = 0.0;
 int count = 0;
 
 freq.resize(geno.cols);

 for(int i=0; i<geno.cols; i++)
 {
  total = 0.0; 
  count = 0;

  for(int p=0; p<geno.rows; p++)
   if(geno[p][i]>0) 
   {
     total += geno[p][i];
     count++;
   }
  freq[i] = (total+0.5)/(count+0.5);
  if(freq[i]>0.5)
  { 
	freq[i] = 1-freq[i];
	for(int p=0; p<geno.rows; p++)
	 geno[p][i] = 2-geno[p][i];
  }
 }
}

void MarkerGroupData::EstimateAlleleFreq_BLUE() {}

void MarkerGroupData::EstimateAlleleFreq_case()
{}

void MarkerGroupData::EstimateAlleleFreq_ctrl()
{}

void MarkerGroupData::FilterGenotypeByFreq(double &min_freq)
{}

void MarkerGroupData::WeightedSum(Matrix& wt)
{
 geno_ws.Product(geno, wt);
}

void MarkerGroupData::WeightedSum(std::vector<float>& w)
{
 Matrix wt;
 wt.Dimension(w.size(), 1);
 for(int i=0; i<w.size(); i++)
  wt[i][0] = w[i];
 geno_ws.Product(geno, wt);
}

void MarkerGroupData::CountRareVariants(Vector &status)
{
 Matrix one_mat;
 Matrix ws_mat;

 one_mat.Dimension(geno.cols,1);
 one_mat.Set(1.0);
 ws_mat.Product(geno, one_mat);

 for(int i=0; i<ws_mat.rows; i++)
 {
  if(ws_mat[i][0]<0 || status[i]!=0 && status[i]!=1) continue;
  if(status[i]==1) { case_var_count+=ws_mat[i][0]; if(ws_mat[i][0]>0.0) case_carrier_count++; }
  if(status[i]==0) { ctrl_var_count+=ws_mat[i][0]; if(ws_mat[i][0]>0.0) ctrl_carrier_count++; }
 } 
}

void MarkerGroupData::Add1Col2Left(Matrix &orig, Matrix &dest)
{
 dest.Dimension(orig.rows, orig.cols+1);
 for(int i=0; i<dest.rows; i++)
  for(int j=0; j<dest.cols; j++)
  {
   if(j==0) { dest[i][j] = 1.0; continue; }
   dest[i][j] = orig[i][j-1];
  }
}

void MarkerGroupData::PrintMarkerData()
{
 for(int i=0; i<geno.rows; i++)
 {
  for(int j=0; j<geno.cols; j++)
   printf("%f ", geno[i][j]);
  printf("\n");
 }
}

void MarkerGroupData::PrintMarkerData(Matrix &geno)
{
 for(int i=0; i<geno.rows; i++)
 {
  for(int j=0; j<geno.cols; j++)
   printf("%f ", geno[i][j]);
  printf("\n");
 }
}

