#ifndef __MARKERGROUPDATA_H__
#define __MARKERGROUPDATA_H__

#include "PedKinship.h"
#include "Pedigree.h"
#include "MathMatrix.h"
#include <vector>

class MarkerGroupData
{
 public:
  Matrix geno;
  Matrix geno_ws;
  PedKinship pedkin;

  std::vector<float> freq;
  std::vector<float> freq_case;
  std::vector<float> freq_ctrol;

  float case_var_count; //these can be used for dosage as well
  float ctrl_var_count;
  int case_carrier_count;
  int ctrl_carrier_count;

 public:
  MarkerGroupData();
 ~MarkerGroupData();
  void EstimateAlleleFreq();
  void EstimateAlleleFreq_case();
  void EstimateAlleleFreq_ctrl();
  void EstimateAlleleFreq_BLUE();
  void FilterGenotypeByFreq(double &min_freq);
  void WeightedSum(Matrix&);
  void WeightedSum(std::vector<float>&);
  void CountRareVariants(Vector&);
  void Add1Col2Left(Matrix &, Matrix &);
  void PrintMarkerData();
  void PrintMarkerData(Matrix&);
};

#endif
