#include "PedPhenoData.h"

PedPhenoData::PedPhenoData()
{}

PedPhenoData::~PedPhenoData(){}

void PedPhenoData::SetPedigree(Pedigree *ptr)
{
 ped = ptr;
 nIndividuals=0;
 for(int i=0; i<ped->familyCount; i++)
   nIndividuals += ped->families[i]->count;

 Person *p;
 p = ped->persons[ped->families[0]->path[0]];

 affectionCount = p->affectionCount;
 traitCount = p->traitCount;
 covariateCount = p->covariateCount;

  affections.Dimension(affectionCount, nIndividuals);
  isDiagnosed.Dimension(affectionCount, nIndividuals);
  isDiagnosed.Zero();

  traits.Dimension(traitCount, nIndividuals);
  isPhenotyped.Dimension(traitCount, nIndividuals);
  isPhenotyped.Zero();

  covariates.Dimension(covariateCount, nIndividuals);
  isControlled.Dimension(covariateCount, nIndividuals);
  isControlled.Zero();

}

void PedPhenoData::GetPhenotypeData()
{
      int pid_index = 0;
      Person *p;

	for(int i=0; i<ped->familyCount; i++)
	 for(int j=0; j<ped->families[i]->count; j++)
         {
	  p = ped->persons[ped->families[i]->path[j]];

          for(int k=0; k<p->affectionCount; k++) 
	   affections[k][pid_index] = p->affections[k]-1;

          for(int k=0; k<p->traitCount; k++)  
	   traits[k][pid_index] = p->traits[k];

          for(int k=0; k<p->covariateCount; k++)  
	   covariates[k][pid_index] = p->covariates[k];

          pid_index++;
         }
}

void PedPhenoData::GetPIDs()
{
  pids.clear();
  pids_map.clear();
  int counter = 0;
  for(int i=0; i<ped->familyCount; i++)
    for(int j=0; j<ped->families[i]->count; j++)
     {
            Person *p;
            p = ped->persons[ped->families[i]->path[j]];
            pids.push_back(std::string(p->pid.c_str()) );
	    pids_map[std::string(p->pid.c_str())] = counter++;
     }
}
