#ifndef __PEDPHENODATA_H__
#define __PEDPHENODATA_H__

#include "Pedigree.h"
#include <string>
#include <vector>
#include <map>
#include "MathVector.h"
#include "MathMatrix.h"

using namespace std;

class PedPhenoData
{
 public:
  Pedigree *ped;
  std::vector<std::string> pids;
  std::map<std::string, int> pids_map;
  int nIndividuals;

  int affectionCount;
  Matrix affections;
  Matrix isDiagnosed;

  int traitCount;
  Matrix traits;
  Matrix isPhenotyped;

  int covariateCount;
  Matrix covariates;
  Matrix isControlled;
  

 public:
  PedPhenoData();
 ~PedPhenoData();
  void SetPedigree(Pedigree *p);
  void GetPIDs();
  void GetPhenotypeData();
};

#endif
