#ifndef __MARKERGROUP_H__
#define __MARKERGROUP_H__

#include <string>
#include <vector>
#include <map>

using namespace std;

class GroupInfo
{
 public:
  std::string group_name;
  std::vector<int> pos;
  std::vector<float> weight;
  std::vector<float> weight_one;
  std::vector<float> freq;
  std::vector<std::string> chr;
  std::map<std::string, int> chr_map;
  std::vector<std::string> chr_uniq;
  std::string chr_str; // string of all chr in the group sepeartged by ';'
  std::vector<std::string> range;
  int start, end, count;

  bool isChrX;
  bool isChrY;
  bool isChrMT;

 public:
  GroupInfo();
 ~GroupInfo();

};

class MarkerGroup
{
 public:
  std::map<std::string, int> index;
  std::vector<std::string> group_names;
  std::map<std::string, GroupInfo> groups;
  bool has_weight;
  bool has_freq;
  std::string chrX;
  std::string chrY;
  std::string chrMT;

  int count;
  double min_freq;
  double max_freq;

 public:
  MarkerGroup();
 ~MarkerGroup();
  void SetMinMaxFreq(double min, double max);
  void LoadMarkerGroupInfo(std::string);
  void CheckChromCompatability();
  void PrintGroupInfo();
};

#endif
